import gleam/dynamic.{type Dynamic}
import gleam/dynamic/decode.{type Decoder}
import gleam/option.{type Option}
import utils/decode as decode_utils

pub type AgentEvent {
  AgentEvent(
    id: String,
    type_: String,
    message: String,
    data: Option(Dynamic),
    created_at: String,
  )
}

pub fn decoder() -> Decoder(AgentEvent) {
  use id <- decode.field("id", decode.string)
  use type_ <- decode.field("type", decode.string)
  use message <- decode.field("message", decode.string)
  use data <- decode_utils.field_key_value_optional("data", decode.dynamic)
  use created_at <- decode.field("createdAt", decode.string)
  decode.success(AgentEvent(id:, type_:, message:, data:, created_at:))
}
