import gleam/dynamic/decode.{type Decoder}

pub type ContractDeliverGood {
  ContractDeliverGood(
    trade_symbol: String,
    destination_symbol: String,
    units_required: Int,
    units_fulfilled: Int,
  )
}

pub fn decoder() -> Decoder(ContractDeliverGood) {
  use trade_symbol <- decode.field("tradeSymbol", decode.string)
  use destination_symbol <- decode.field("destinationSymbol", decode.string)
  use units_required <- decode.field("unitsRequired", decode.int)
  use units_fulfilled <- decode.field("unitsFulfilled", decode.int)
  decode.success(ContractDeliverGood(
    trade_symbol:,
    destination_symbol:,
    units_required:,
    units_fulfilled:,
  ))
}
