import gleam/dynamic/decode.{type Decoder}
import gleam/option.{type Option}
import models/contract_deliver_good.{type ContractDeliverGood}
import models/contract_payment.{type ContractPayment}
import utils/decode as decode_utils

pub type ContractTerms {
  ContractTerms(
    deadline: String,
    payment: ContractPayment,
    deliver: Option(List(ContractDeliverGood)),
  )
}

pub fn decoder() -> Decoder(ContractTerms) {
  use deadline <- decode.field("deadline", decode.string)
  use payment <- decode.field("payment", contract_payment.decoder())
  use deliver <- decode_utils.field_key_value_optional(
    "deliver",
    decode.list(contract_deliver_good.decoder()),
  )
  decode.success(ContractTerms(deadline:, payment:, deliver:))
}
