import gleam/dynamic/decode.{type Decoder}
import utils/decode as decode_utils

pub type MountSymbol {
  MountGasSiphonI
  MountGasSiphonII
  MountGasSiphonIII
  MountSurveyorI
  MountSurveyorII
  MountSurveyorIII
  MountSensorArrayI
  MountSensorArrayII
  MountSensorArrayIII
  MountMiningLaserI
  MountMiningLaserII
  MountMiningLaserIII
  MountLaserCannonI
  MountMissileLauncherI
  MountTurretI
}

pub fn to_string(mount_symbol: MountSymbol) -> String {
  case mount_symbol {
    MountGasSiphonI -> "MOUNT_GAS_SIPHON_I"
    MountGasSiphonII -> "MOUNT_GAS_SIPHON_II"
    MountGasSiphonIII -> "MOUNT_GAS_SIPHON_III"
    MountSurveyorI -> "MOUNT_SURVEYOR_I"
    MountSurveyorII -> "MOUNT_SURVEYOR_II"
    MountSurveyorIII -> "MOUNT_SURVEYOR_III"
    MountSensorArrayI -> "MOUNT_SENSOR_ARRAY_I"
    MountSensorArrayII -> "MOUNT_SENSOR_ARRAY_II"
    MountSensorArrayIII -> "MOUNT_SENSOR_ARRAY_III"
    MountMiningLaserI -> "MOUNT_MINING_LASER_I"
    MountMiningLaserII -> "MOUNT_MINING_LASER_II"
    MountMiningLaserIII -> "MOUNT_MINING_LASER_III"
    MountLaserCannonI -> "MOUNT_LASER_CANNON_I"
    MountMissileLauncherI -> "MOUNT_MISSILE_LAUNCHER_I"
    MountTurretI -> "MOUNT_TURRET_I"
  }
}

pub fn parse(mount_symbol_str: String) -> Result(MountSymbol, MountSymbol) {
  case mount_symbol_str {
    "MOUNT_GAS_SIPHON_I" -> Ok(MountGasSiphonI)
    "MOUNT_GAS_SIPHON_II" -> Ok(MountGasSiphonII)
    "MOUNT_GAS_SIPHON_III" -> Ok(MountGasSiphonIII)
    "MOUNT_SURVEYOR_I" -> Ok(MountSurveyorI)
    "MOUNT_SURVEYOR_II" -> Ok(MountSurveyorII)
    "MOUNT_SURVEYOR_III" -> Ok(MountSurveyorIII)
    "MOUNT_SENSOR_ARRAY_I" -> Ok(MountSensorArrayI)
    "MOUNT_SENSOR_ARRAY_II" -> Ok(MountSensorArrayII)
    "MOUNT_SENSOR_ARRAY_III" -> Ok(MountSensorArrayIII)
    "MOUNT_MINING_LASER_I" -> Ok(MountMiningLaserI)
    "MOUNT_MINING_LASER_II" -> Ok(MountMiningLaserII)
    "MOUNT_MINING_LASER_III" -> Ok(MountMiningLaserIII)
    "MOUNT_LASER_CANNON_I" -> Ok(MountLaserCannonI)
    "MOUNT_MISSILE_LAUNCHER_I" -> Ok(MountMissileLauncherI)
    "MOUNT_TURRET_I" -> Ok(MountTurretI)
    _ -> Error(MountGasSiphonI)
  }
}

pub fn decoder() -> Decoder(MountSymbol) {
  decode_utils.enum_decoder(parse, "MountSymbol")
}
