import gleam/dynamic/decode.{type Decoder}
import utils/decode as decode_utils

pub type ReactorSymbol {
  ReactorSolarI
  ReactorFusionI
  ReactorFissionI
  ReactorChemicalI
  ReactorAntimatterI
}

pub fn to_string(reactor_symbol: ReactorSymbol) -> String {
  case reactor_symbol {
    ReactorSolarI -> "REACTOR_SOLAR_I"
    ReactorFusionI -> "REACTOR_FUSION_I"
    ReactorFissionI -> "REACTOR_FISSION_I"
    ReactorChemicalI -> "REACTOR_CHEMICAL_I"
    ReactorAntimatterI -> "REACTOR_ANTIMATTER_I"
  }
}

pub fn parse(reactor_symbol_str: String) -> Result(ReactorSymbol, ReactorSymbol) {
  case reactor_symbol_str {
    "REACTOR_SOLAR_I" -> Ok(ReactorSolarI)
    "REACTOR_FUSION_I" -> Ok(ReactorFusionI)
    "REACTOR_FISSION_I" -> Ok(ReactorFissionI)
    "REACTOR_CHEMICAL_I" -> Ok(ReactorChemicalI)
    "REACTOR_ANTIMATTER_I" -> Ok(ReactorAntimatterI)
    _ -> Error(ReactorSolarI)
  }
}

pub fn decoder() -> Decoder(ReactorSymbol) {
  decode_utils.enum_decoder(parse, "ReactorSymbol")
}
