import gleam/dynamic/decode.{type Decoder}
import utils/decode as decode_utils

pub type ShipComponent {
  Frame
  Reactor
  Engine
}

pub fn to_string(ship_component: ShipComponent) -> String {
  case ship_component {
    Frame -> "FRAME"
    Reactor -> "REACTOR"
    Engine -> "ENGINE"
  }
}

pub fn parse(ship_component_str: String) -> Result(ShipComponent, ShipComponent) {
  case ship_component_str {
    "FRAME" -> Ok(Frame)
    "REACTOR" -> Ok(Reactor)
    "ENGINE" -> Ok(Engine)
    _ -> Error(Frame)
  }
}

pub fn decoder() -> Decoder(ShipComponent) {
  decode_utils.enum_decoder(parse, "ShipComponent")
}
