import gleam/dynamic/decode.{type Decoder}
import gleam/option.{type Option}
import models/ship_fuel_consumed.{type ShipFuelConsumed}
import utils/decode as decode_utils

pub type ShipFuel {
  ShipFuel(current: Int, capacity: Int, consumed: Option(ShipFuelConsumed))
}

pub fn decoder() -> Decoder(ShipFuel) {
  use current <- decode.field("current", decode.int)
  use capacity <- decode.field("capacity", decode.int)
  use consumed <- decode_utils.field_key_value_optional(
    "consumed",
    ship_fuel_consumed.decoder(),
  )
  decode.success(ShipFuel(current:, capacity:, consumed:))
}
