import gleam/dynamic/decode.{type Decoder}
import models/ship_nav_route_waypoint.{type ShipNavRouteWaypoint}

pub type ShipNavRoute {
  ShipNavRoute(
    destination: ShipNavRouteWaypoint,
    origin: ShipNavRouteWaypoint,
    departure_time: String,
    arrival: String,
  )
}

pub fn decoder() -> Decoder(ShipNavRoute) {
  use destination <- decode.field(
    "destination",
    ship_nav_route_waypoint.decoder(),
  )
  use origin <- decode.field("origin", ship_nav_route_waypoint.decoder())
  use departure_time <- decode.field("departureTime", decode.string)
  use arrival <- decode.field("arrival", decode.string)
  decode.success(ShipNavRoute(destination:, origin:, departure_time:, arrival:))
}
