import gleam/dynamic/decode.{type Decoder}
import gleam/option.{type Option}
import utils/decode as decode_utils

pub type ShipRequirements {
  ShipRequirements(power: Option(Int), crew: Option(Int), slots: Option(Int))
}

pub fn decoder() -> Decoder(ShipRequirements) {
  use power <- decode_utils.field_key_value_optional("power", decode.int)
  use crew <- decode_utils.field_key_value_optional("crew", decode.int)
  use slots <- decode_utils.field_key_value_optional("slots", decode.int)
  decode.success(ShipRequirements(power:, crew:, slots:))
}
