import gleam/dynamic/decode.{type Decoder}
import utils/decode as decode_utils

pub type ShipType {
  ShipProbe
  ShipMiningDrone
  ShipSiphonDrone
  ShipInterceptor
  ShipLightHauler
}

pub fn to_string(ship_type: ShipType) -> String {
  case ship_type {
    ShipProbe -> "SHIP_PROBE"
    ShipMiningDrone -> "SHIP_MINING_DRONE"
    ShipSiphonDrone -> "SHIP_SIPHON_DRONE"
    ShipInterceptor -> "SHIP_INTERCEPTOR"
    ShipLightHauler -> "SHIP_LIGHT_HAULER"
  }
}

pub fn parse(ship_type_str: String) -> Result(ShipType, ShipType) {
  case ship_type_str {
    "SHIP_PROBE" -> Ok(ShipProbe)
    "SHIP_MINING_DRONE" -> Ok(ShipMiningDrone)
    "SHIP_SIPHON_DRONE" -> Ok(ShipSiphonDrone)
    "SHIP_INTERCEPTOR" -> Ok(ShipInterceptor)
    "SHIP_LIGHT_HAULER" -> Ok(ShipLightHauler)
    _ -> Error(ShipProbe)
  }
}

pub fn decoder() -> Decoder(ShipType) {
  decode_utils.enum_decoder(parse, "ShipType")
}
