import gleam/dynamic/decode.{type Decoder}
import gleam/json.{type Json}
import utils/decode as decode_utils

pub type SurveySize {
  Small
  Moderate
  Large
}

pub fn to_string(survey_size: SurveySize) -> String {
  case survey_size {
    Small -> "SMALL"
    Moderate -> "MODERATE"
    Large -> "LARGE"
  }
}

pub fn parse(survey_size_str: String) -> Result(SurveySize, SurveySize) {
  case survey_size_str {
    "SMALL" -> Ok(Small)
    "MODERATE" -> Ok(Moderate)
    "LARGE" -> Ok(Large)
    _ -> Error(Small)
  }
}

pub fn encode(survey_size: SurveySize) -> Json {
  json.string(to_string(survey_size))
}

pub fn decoder() -> Decoder(SurveySize) {
  decode_utils.enum_decoder(parse, "SurveySize")
}
