import gleam/dynamic/decode.{type Decoder}
import utils/decode as decode_utils

pub type TradeGoodType {
  Import
  Export
  Exchange
}

pub fn to_string(trade_good_type: TradeGoodType) -> String {
  case trade_good_type {
    Import -> "IMPORT"
    Export -> "EXPORT"
    Exchange -> "EXCHANGE"
  }
}

pub fn parse(
  trade_good_type_str: String,
) -> Result(TradeGoodType, TradeGoodType) {
  case trade_good_type_str {
    "IMPORT" -> Ok(Import)
    "EXPORT" -> Ok(Export)
    "EXCHANGE" -> Ok(Exchange)
    _ -> Error(Import)
  }
}

pub fn decoder() -> Decoder(TradeGoodType) {
  decode_utils.enum_decoder(parse, "TradeGoodType")
}
