import gleam/dynamic.{type Dynamic}
import gleam/httpc.{type HttpError}
import gleam/json.{type DecodeError}
import gleam/option.{type Option}
import models/meta.{type Meta}

pub type PagedData(data) {
  PagedData(data: data, meta: Meta)
}

pub type ErrorResponse {
  ErrorResponse(
    code: Int,
    message: String,
    data: Option(Dynamic),
    request_id: Option(String),
  )
}

pub type ApiError {
  HttpcError(HttpError)
  JsonDecodeError(DecodeError)
  ResponseError(ErrorResponse)
  UnknownError
}

pub type ApiResponse(a) =
  Result(a, ApiError)
